"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const testing_1 = require("@graphql-codegen/testing");
const __1 = require("..");
const __fixtures__1 = require("./__fixtures__");
const plugin_helpers_1 = require("@graphql-codegen/plugin-helpers");
describe('Sqlmancer Plugin', () => {
    describe('schema without directives', () => {
        it('Should generate SqlmancerClient and resolver types', async () => {
            const result = await __1.plugin(__fixtures__1.schemaWithoutDirectives, [], {}, { outputFile: '' });
            const merged = plugin_helpers_1.mergeOutputs([result]);
            testing_1.validateTs(merged);
            expect(merged).toMatchSnapshot();
        });
        it('Should generate only SqlmancerClient types', async () => {
            const result = await __1.plugin(__fixtures__1.schemaWithoutDirectives, [], { withResolvers: false }, { outputFile: '' });
            const merged = plugin_helpers_1.mergeOutputs([result]);
            testing_1.validateTs(merged);
            expect(merged).toMatchSnapshot();
        });
    });
    describe('schema with directives', () => {
        it('Should generate SqlmancerClient and resolver types', async () => {
            const result = await __1.plugin(__fixtures__1.schemaWithDirectives, [], {}, { outputFile: '' });
            const merged = plugin_helpers_1.mergeOutputs([result]);
            testing_1.validateTs(merged);
            expect(merged).toMatchSnapshot();
        });
        it('Should generate only SqlmancerClient types', async () => {
            const result = await __1.plugin(__fixtures__1.schemaWithDirectives, [], { withResolvers: false }, { outputFile: '' });
            const merged = plugin_helpers_1.mergeOutputs([result]);
            testing_1.validateTs(merged);
            expect(merged).toMatchSnapshot();
        });
    });
});
//# sourceMappingURL=plugin.spec.js.map